/*
 * @(#)Hextris.h
 *
 * Copyright 1993 - 2008  David A. Bagley, bagleyd@tux.org
 *
 * Taken from GENERIC X-BASED TETRIS
 *
 * Copyright 1992 - 1995  Q. Alex Zhao, azhao@cc.gatech.edu
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Public header file for Hextris */

#ifndef _XtHextris_h
#define _XtHextris_h

/***********************************************************************
 *
 * Hextris Widget
 *
 ***********************************************************************/

#ifndef WINVER
#define XtNmono ((char *) "mono")
#define XtNdelay ((char *) "delay")
#define XtNsound ((char *) "sound")
#define XtNbumpSound ((char *) "bumpSound")
#define XtNlevel ((char *) "level")
#define XtNcolumns ((char *) "columns")
#define XtNunits ((char *) "units")
#define XtNfill ((char *) "fill")
#define XtNfixedFill ((char *) "fixedFill")
#define XtNsuddenAppear ((char *) "suddenAppear")
#define XtNcorners ((char *) "corners")
#define XtNmixed ((char *) "mixed")
#define XtNbonus ((char *) "bonus")
#define XtNplainPiece ((char *) "plainPiece")
#define XtNcw ((char *) "cw")
#define XtNshowNext ((char *) "showNext")
#define XtNgrid ((char *) "grid")
#define XtNscore ((char *) "score")
#define XtNcompletedRows ((char *) "completedRows")
#define XtNuserName ((char *) "userName")
#define XtNscoreFile ((char *) "scoreFile")
#define XtNscoreOnly ((char *) "scoreOnly")
#define XtNversionOnly ((char *) "versionOnly")
#define XtNmenu ((char *) "menu")
#define XtNstart ((char *) "start")
#define XtNact ((char *) "act")
#define XtNrandomNumber ((char *) "randomNumber")
#define XtNrandomRotation ((char *) "randomRotation")
#define XtNrandomReflection ((char *) "randomReflection")
#define XtNpixmapSize ((char *) "pixmapSize")
#define XtNselectCallback ((char *) "selectCallback")
#define XtCMono ((char *) "Mono")
#define XtCDelay ((char *) "Delay")
#define XtCSound ((char *) "Sound")
#define XtCBumpSound ((char *) "BumpSound")
#define XtCLevel ((char *) "Level")
#define XtCUnits ((char *) "Units")
#define XtCColumns ((char *) "Columns")
#define XtCFill ((char *) "Fill")
#define XtCFixedFill ((char *) "FixedFill")
#define XtCSuddenAppear ((char *) "SuddenAppear")
#define XtCCorners ((char *) "Corners")
#define XtCMixed ((char *) "Mixed")
#define XtCBonus ((char *) "Bonus")
#define XtCPlainPiece ((char *) "PlainPiece")
#define XtCCw ((char *) "Cw")
#define XtCShowNext ((char *) "ShowNext")
#define XtCGrid ((char *) "Grid")
#define XtCLevel ((char *) "Level")
#define XtCScore ((char *) "Score")
#define XtCCompletedRows ((char *) "CompletedRows")
#define XtCUserName ((char *) "UserName")
#define XtCScoreFile ((char *) "ScoreFile")
#define XtCMenu ((char *) "Menu")
#define XtCAct ((char *) "Act")
#define XtCRandomNumber ((char *) "RandomNumber")
#define XtCRandomRotation ((char *) "RandomRotation")
#define XtCRandomReflection ((char *) "RandomReflection")
#define XtCPixmapSize ((char *) "PixmapSize")

typedef struct _HextrisClassRec *HextrisWidgetClass;

extern WidgetClass hextrisWidgetClass;

typedef struct {
	XEvent     *event;
	int         reason;
	int         randomNumber, randomRotation, randomReflection;
	Boolean     newBonus;
	int         units;
	Boolean     corners, mixed;
} hextrisCallbackStruct;
#endif

#define ACTION_EXIT 100
#define ACTION_HIDE 101
#define ACTION_RESTART_QUERY 102
#define ACTION_STATUS 103
#define ACTION_GAME_OVER 104
#define ACTION_STARTED 105
#define ACTION_PAUSE 106
#define ACTION_CLEAR 107
#define ACTION_DRAW_NEXT 200
#define ACTION_INC_UNITS 201
#define ACTION_DEC_UNITS 202
#define ACTION_INC_COLUMNS 203
#define ACTION_DEC_COLUMNS 204
#define ACTION_FIXED_FILL 205
#define ACTION_SUDDEN_APPEAR 206
#define ACTION_CORNERS 207
#define ACTION_MIXED 208
#define ACTION_BONUS 209
#define ACTION_CW 210
#define ACTION_PLAIN_PIECE 211
#define ACTION_SHOW_NEXT 212
#define ACTION_GRID 213
#define ACTION_SOUND 214
#define ACTION_DROP 301
#define ACTION_LEFT 302
#define ACTION_RIGHT 303
#define ACTION_ROTATE 304
#define ACTION_REFLECT 305
#define ACTION_FILL0 400
#define ACTION_FILL1 401
#define ACTION_FILL2 402
#define ACTION_FILL3 403
#define ACTION_FILL4 404
#define ACTION_FILL5 405
#define ACTION_FILL6 406
#define ACTION_FILL7 407
#define ACTION_FILL8 408
#define ACTION_FILL9 409
#define ACTION_FILL10 410
#define ACTION_INC_LEVEL 500
#define ACTION_DEC_LEVEL 501
#define ACTION_ABOUT 900
#define ACTION_DESCRIPTION 901
#define ACTION_FEATURES 902
#define ACTION_REFERENCES 903
#define ACTION_IGNORE 999

#define CLEARNEXT_RAND (-2)
#define IGNORE_RAND (-1)
#define MIN_LEVELS 1
#define MAX_LEVELS 20
#define DEFAULT_LEVELS 3
#define MIN_UNITS 2 /* Why not 1 you say? */
#define MAX_UNITS 5
#define DEFAULT_UNITS 4
#define MIN_COLUMNS MAX_UNITS
#define MAX_COLUMNS 30
#define DEFAULT_COLUMNS 10
#define MAX_FILL DEFAULT_COLUMNS
#define MIN_CORNERUNITS MIN_UNITS
#define MAX_CORNERUNITS	4
#define DEFAULT_CORNERS FALSE
#define DEFAULT_MIXED FALSE

#ifdef MONOTEST
#define DEFAULT_MONO TRUE
#else
#define DEFAULT_MONO FALSE
#endif
#define DEFAULT_REVERSE FALSE

#define LEGAL(n,g,m,b) (((n)>=MIN_UNITS+(m))&&\
			((n)<=((g)?MAX_CORNERUNITS:MAX_UNITS)-(b)))

typedef struct _HextrisRec *HextrisWidget;

#endif /* _XtHextris_h */
/* DON'T ADD STUFF AFTER THIS #endif */
