/*
 * @(#)HextrisNP.h
 *
 * Copyright 1994 - 2008  David A. Bagley, bagleyd@tux.org
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/* Next private header file for Hextris */

#ifndef _HextrisNP_h
#define _HextrisNP_h
#include "HextrisP.h"
#include "HextrisN.h"

#ifdef WINVER
extern void destroyNextGame(HBRUSH brush);
extern void resizeNextGame(NextHextrisWidget w);
#if 0
extern void sizeNextGame(NextHextrisWidget w);
#endif
extern void initializeNextGame(NextHextrisWidget w, HBRUSH brush);
extern void exposeNextGame(NextHextrisWidget w);
extern void hideNextGame(NextHextrisWidget w);
extern void ToggleNextGame(NextHextrisWidget w);
extern void enterNextGame(NextHextrisWidget w);
extern void leaveNextGame(NextHextrisWidget w);
extern Boolean DiagonalNextGame(NextHextrisWidget w);
extern void toggleSoundNextGame(NextHextrisWidget w);
extern Boolean MixedNextGame(NextHextrisWidget w);
extern void valueNextGame(NextHextrisWidget w,
	int randomNumber, int randomRotation, int randomRefleection,
	int units, Boolean corners, Boolean mixed, Boolean newBonus);
extern void showNextNextGame(NextHextrisWidget w);
extern void setNextGame(NextHextrisWidget w, int reason);
#else

typedef struct _NextHextrisPart
{
	int randomNumber, randomRotation, randomReflection;
	Boolean newBonus;
} NextHextrisPart;
#endif

typedef struct _NextHextrisRec
{
	CorePart core;
	HextrisPart hextris;
#ifndef WINVER
	NextHextrisPart nextHextris;
#endif
} NextHextrisRec;

#ifndef WINVER
/* This gets around C's inability to do inheritance */
typedef struct _NextHextrisClassPart
{
	int ignore;
} NextHextrisClassPart;

typedef struct _NextHextrisClassRec
{
	CoreClassPart coreClass;
	HextrisClassPart hextrisClass;
	NextHextrisClassPart nextHextrisClass;
} NextHextrisClassRec;

extern NextHextrisClassRec nextHextrisClassRec;
#endif
#endif /* _HextrisNP_h */
