/*
 * @(#)polyiamond.h
 *
 * Copyright 1993 - 2008  David A. Bagley, bagleyd@tux.org
 *
 * All rights reserved.
 *
 * Permission to use, copy, modify, and distribute this software and
 * its documentation for any purpose and without fee is hereby granted,
 * provided that the above copyright notice appear in all copies and
 * that both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of the author not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 * This program is distributed in the hope that it will be "useful",
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

#define MIN_UNITS	2 /* Why not 1 you say? */
#define MAX_UNITS	8
#define MIN_DIAGONALUNITS	MIN_UNITS
#define MAX_DIAGONALUNITS	2

#define NODIAG		0 /* Normal, ie no diagonals */
#define DIAGONAL	1 /* Normal and diagonal */
#define NOMIX		0 /* Do not mix lowered number squares with current */
#define MIXED		1
#define MAX_MODES	2
#define NONE		0 /* No rotation or reflection */
#define NOREFL		1 /* Normal, no reflection allow rotation */
#define ALL		2 /* Allow reflection or rotation */
#define MAX_TURNSTYLE_TYPES	3
#define DEFAULT_UNITS	5
#define DEFAULT_DIAGONALUNITS	2
#define MAX_POLYIAMONDS	675
#define MAX_START_POLYIAMONDS	111
#define HEX_SIZE	3
#define HEX_COL(i)	(4*i-1)
#define HEX_ROW(j)	(2*j)
#define JUMPIN		0
#define GRADUAL		1

typedef struct {
	int         rotation;
	int         reflection;
	int         startHeight[2];
	int         shape[HEX_ROW(HEX_SIZE)][HEX_COL(HEX_SIZE)];
	int         size;
} Polyiamonds;
typedef struct {
	int         number[MAX_MODES][MAX_TURNSTYLE_TYPES];
	int         start[MAX_START_POLYIAMONDS][MAX_TURNSTYLE_TYPES];
	int         turnStyle;
} Mode;
typedef struct {
	Polyiamonds polyiamond[MAX_POLYIAMONDS];
	Mode        mode[MAX_MODES];
	char        diagonalSwitch;
} Polytris;

extern Polytris tris[MAX_UNITS - MIN_UNITS + 1];
#ifdef WINVER
extern const char *polyiamondColorString[MAX_START_POLYIAMONDS];
#else
extern const char *polyiamondColorName[MAX_START_POLYIAMONDS];
#endif
extern int inHexagon(int size, int i, int j);
extern void readThings(void);
